# GUI development with Rust and GTK 4

[Introduction](introduction.md)
- [Installation](installation.md)
    - [Linux](installation_linux.md)
    - [macOS](installation_macos.md)
    - [Windows](installation_windows.md)
- [Project Setup](project_setup.md)
- [Hello World!](hello_world.md)
- [Widgets](widgets.md)
- [GObject Concepts](g_object_concepts.md)
    - [Memory Management](g_object_memory_management.md)
    - [Subclassing](g_object_subclassing.md)
    - [Generic Values](g_object_values.md)
    - [Properties](g_object_properties.md)
    - [Signals](g_object_signals.md)
- [The Main Event Loop](main_event_loop.md)
- [Settings](settings.md)
- [Saving Window State](saving_window_state.md)
- [List Widgets](list_widgets.md)
- [Composite Templates](composite_templates.md)
- [Building a Simple To-Do App](todo_1.md)
- [Actions](actions.md)
- [Manipulating State of To-Do App](todo_2.md)
- [CSS](css.md)
- [Libadwaita](libadwaita.md)
    - [Let To-Do App use Libadwaita](todo_3.md)
    - [Adding Collections](todo_4.md)
